.nolist
include \masm32\include\masm32rt.inc

GetSetProfile	PROTO :DWORD,:DWORD,:DWORD	; reads & writes to ini file
		    ;  pName, pValue,pReturn

BufLen	EQU 512	; length of local general purpose buffer
crlf	EQU 13,10

.data?
CtArg		dd ?	; counter
msg		MSG <>	; ->message loop, we only need WM_TIMER
Ct65k		dd ?	; counter 65k
prof4b		dd ?	; 4 bytes for use with GetSetProfile
pND		dd ?	; pointer NoDefault for use with GetSetProfile
WaitMs		dd ?	; Wait n milliseconds before launching the proggie
arrayCL		dd 2*9 dup (?)	; array command lines and ids
pLastCL		dd ?		; pointer to the last command line
p2array		dd ?		; pointer to the array
ComLine		db 800 dup (?)	; 9*90 should be enough
pDwToA		dd ?		; pointer to dwtoaBuf
dwtoaBuf	db 80 dup (?)	; ca. 48 for the number
ErrBuf		db 1024 dup (?)

.data
AppName		db "Startup",0
IniFile  	db "\StartUp.ini",0
SectApp		db "AppOptions",0
NoDefStr	db "$**$"
NumBuf		db "Your number:", crlf,0
UnExp		db "Bad exit: check Clx and Wx entries in StartUp.ini",0
ExErr		db "WinExec:",0
ExErr2		db "Error ",0
ExErr3		db " for",13,10,0

.code
start:	m2m pND, offset NoDefStr	; pointer to $**$

	invoke szCopy, addr NumBuf, addr dwtoaBuf	; 
        invoke szLen, addr dwtoaBuf
	mov edx, offset dwtoaBuf
	add edx, eax
	mov pDwToA, edx	; pointer to the dwtoa buffer used inter alia by GetSetProfile

	xor eax, eax	; zero the two counters:
	mov Ct65k, eax	; 'm2m Ct65k, 0' is ok,
	mov CtArg, eax	; but this saves 2*2 bytes

	mrm p2array, offset arrayCL	; m2m is ok, but mrm
	mrm pLastCL, offset ComLine	; is 2*1 bytes shorter

	.While Ct65k<9*65536		; nine proggies allowed
		mov eax,"1lC"		; read as "Cl1" - first entry in StartUp.ini
		add eax, Ct65k		; Cl1, Cl2, Cl3, ... add 65K to change ah
		mov prof4b, eax		; 4 bytes for GetSetProfile
		mov ecx, p2array
		mov eax, pLastCL	; slot A is pointer to current commandline
		mov [ecx], eax

		; read commandline from StartUp.ini:
		invoke GetSetProfile, addr prof4b, pND, pLastCL
		.break .if eax==0	; no more entries

		mov ecx, pLastCL
		add ecx, len(pLastCL)
		inc ecx
		mov pLastCL, ecx
		mov eax,"1W+"		; +W1, +W2, +W3, ... add 65K to change ah
		add eax, Ct65k
		mov prof4b, eax

		; read WaitMs from StartUp.ini:
		invoke GetSetProfile, addr prof4b, pND, addr WaitMs
		add Ct65k, 65536

		invoke SetTimer, 0, 0, WaitMs, 0
		; MSDN: If the call is not intended to replace an existing
		; timer, nIDEvent should be 0 if the hWnd is NULL.
		; Windows will give you a proper ID in the return value

		mov ecx, p2array
		mov [ecx+4], eax	; slot B is ID of timer

		add ecx, 8
		mov p2array, ecx	; new pair of slots
		inc CtArg
	.Endw

	.While CtArg>1
	  invoke GetMessage, addr msg, 0, 0, 0
	  .break .if eax<=0
	  .IF msg.message==WM_TIMER

		invoke KillTimer, msg.hwnd, msg.wParam

		mov edx, offset arrayCL
		mov ecx, CtArg
		.While ecx>0
		  dec ecx
		  push ecx
		  mov eax,[edx+4]
		  .IF eax==msg.wParam	; that's the right timer
			mov eax, [edx]
			push edx
			invoke WinExec, eax, SW_SHOWNA	; launch but don't activate
			.if eax<=32
			  invoke dwtoa, eax, pDwToA	; WinExec error code
			  mov edx, offset ErrBuf
			  xor eax, eax
			  mov [edx], eax	; clear string
			  invoke lstrcat, edx, addr ExErr2		; Error_
			  invoke lstrcat, addr ErrBuf, pDwToA		; x
			  invoke lstrcat, addr ErrBuf, addr ExErr3	;_for
			  pop edx
			  push edx
			  invoke lstrcat, addr ErrBuf, [edx]	;commandline
			  invoke MessageBox, 0, addr ErrBuf, addr ExErr,MB_OK
			.endif
			pop edx
		  .ENDIF
		  add edx, 8	; next slot, please
		  pop ecx
		.Endw

		sub Ct65k, 65536	; ALL DONE?
		jbe Bye

	  .ENDIF
	.Endw
	invoke MessageBox, 0, addr UnExp, addr AppName, MB_OK	; no entries in StartUp.ini
Bye:	invoke ExitProcess,0

GetSetProfile proc pName:DWORD, pValue:DWORD, pReturn:DWORD
LOCAL LocBuf[BufLen]:BYTE, pBuf:DWORD,pSectName:DWORD
  push ecx
  push edx
  lea eax, LocBuf	; general purpose buffer
  mov pBuf,eax		; pointer to buffer

	invoke GetModuleFileName,0,pBuf,BufLen	; launched from where?
	mov ecx,len(pBuf)
	mov edx,pBuf
	add edx,ecx

@@:	dec ecx		; find first \ from the right
	je @F
	dec edx
	mov al,[edx]
	cmp al,"\"
	jne @B
	xor eax,eax
	mov [edx+1],al

@@:	invoke lstrcat, pBuf, addr IniFile	; MyExePath\StartUp.ini
	mrm pSectName, offset SectApp		; ini needs a section title
	mov eax,pName
	mov al,[eax]
	.if al=="+"			; name starts with "+": store/get a number
		inc pName		; correct the name and transform
		mov eax,pValue		; the number into a pointer
		.if eax!=pND
			mov pValue,sstr$(pValue)
		.endif
		.if pReturn
		  invoke GetPrivateProfileString, pSectName, pName, pValue, pDwToA, BufLen, pBuf
		  mov edx,pDwToA
		  mov edx,[edx]
		  .if edx=="$**$"
			xor eax,eax	; no entry found
		  .else
			push eax	; save return value - sval certainly modifies eax
			mov eax, sval(pDwToA)	; convert returned string to a number
			mov ecx,pReturn		; and shove it into the
			mov [ecx],eax		; waiting DWORD return variable
			pop eax
		  .endif
		.else
		  invoke WritePrivateProfileString, pSectName, pName, pValue, pBuf
		.endif
	.else		; store/get text
	  .if pReturn
		  invoke GetPrivateProfileString, pSectName, pName, pValue, pReturn, BufLen, pBuf
	  .else
		  invoke WritePrivateProfileString, pSectName, pName, pValue, pBuf
	  .endif
	.endif
	.if eax
	  .if pReturn
		mov edx,pReturn
		mov edx,[edx]
		cmp edx,"$**$" ; no default key
		jne @F
		xor eax,eax	; Flag no key found
@@:	
	  .endif	
	.endif
  pop edx
  pop ecx
ret

GetSetProfile endp

end start
OPT_SUSY WINDOWS
OPT_Icon bell
